HonorGoldEnabled = true
HonorGold = CreateFrame("Frame")
HonorGold.timer = 0
HonorGold:Hide()
HonorGold:RegisterEvent("MERCHANT_SHOW")
HonorGold:SetScript("OnEvent", function(self,event)
	if HonorGoldEnabled then
		local link,money,g,s,c,text
		local npc_id = tonumber((select(6,strsplit('-',UnitGUID("target")))))
		money = 0
		for i=0,4 do
			if GetContainerNumSlots(i) then
				for j=1,GetContainerNumSlots(i) do
					link = GetContainerItemLink(i,j)
					if link and tonumber(link:match("item:(%d+)"))==35058 and GetContainerItemPurchaseInfo(i,j)==nil then
						UseContainerItem(i,j)
						money = money+160738
					end
				end
			end
		end
		if money>0 then
			g = floor(money/(COPPER_PER_SILVER*SILVER_PER_GOLD))
			s = floor((money-g*COPPER_PER_SILVER*SILVER_PER_GOLD)/COPPER_PER_SILVER)
			c = mod(money,COPPER_PER_SILVER)
			text = ""
		    if g>0 then
				text = g.." gold"
			end
			if s>0 then
				text = text.." "..s.." silver"
			end
			if c>0 then
				text = text.." "..c.." copper"
			end
			text = text.."."
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold: You received "..text,0,1,0)
		end
		if UnitLevel("player")>=70 and (npc_id==12784 or npc_id==12794 or npc_id==40212 or npc_id==40216) then
			HonorGold:Show()
		end
	end
end)

HonorGold:SetScript("OnUpdate",function(self,elapsed)
	local n = floor(select(2,GetCurrencyInfo(392))/105)
	if HonorGoldEnabled and n>=1 then
		local i,found
		self.timer = self.timer+elapsed
		if self.timer>0.5 and not found then
			self.timer = 0
			MerchantFrame_SetFilter(MerchantFrame,1)
			i = 1
			while i<=GetMerchantNumItems() and not found do
				link = GetMerchantItemLink(i)
				if link and tonumber(link:match("item:(%d+)"))==35058 then
					found = true
				else
					i = i+1
				end
			end
		end
		if found then
			while n>0 do
				BuyMerchantItem(i)
				StaticPopup1Button1:Click()
				n = n-1
			end
			CloseMerchant()
			HonorGold:Hide()
		end
	end
end)

local function HonorGoldToggle()
	if not HonorGoldEnabled then
		HonorGoldEnabled = true
		DEFAULT_CHAT_FRAME:AddMessage("HonorGold enabled.",0,1,0)
	else
		HonorGoldEnabled = false
		DEFAULT_CHAT_FRAME:AddMessage("HonorGold disabled.",1,0,0)
	end
end

SlashCmdList["HonorGold"] = HonorGoldToggle
SLASH_HonorGold1 = "/honorgold"